(defun c:SETLAYER (/ LAYER)
(setq LAYER
   (cdr
      (assoc 8
         (entget
            (car
               (entsel "Pick item for new layer: "
))))))
(command "LAYER" "SET" LAYER "")
)




(setq MacList ())
;FUNCTION MACRO-creates keyboard macros.
(defun C:MACRO ()
   (setq Key (getstring "\nMacro Key(s):"))
   (setq Key (strcat "C:" Key))
   (cond((/= Key "C:")
      (setq Mac (list 'Command))
      (setq Cmd "")
      (While(/= Cmd ".")
         (setq Cmd (getstring "\nMacro Def (. to end): "))
         (If(/= Cmd ".")(setq Mac (cons Cmd Mac)))
      )
      (setq Ans "")
      (While (NOT (member Ans '("Y" "y" "N" "n")))
         (setq Ans (getstring "\nCreate Macro (Y/N): ")))
      (cond ((member Ans '("Y" "y"))
         (setq Mac (reverse Mac))
         (setq MacDef (list 'defun (read Key) '() Mac))
         (setq MacList (cons MacDef MacList))
         (eval MacDef))
      ))
   )
)

;FUNCTION C:MACSAVE-saves macros defined in this session to disk.
(defun C:MACSAVE ()
   (setq Exist "T")
   (While (= Exist "T")
      (setq FN "")
      (While(= FN "")
         (setq FN (getstring "\nFilename: ")))
      (setq FN (strcat FN ".LSP"))
      (setq FU (open FN "r")) ;check for existing file
      (cond ((NULL FU)
               (setq Exist "N"))
         (T
               (close FU)
               (setq Ans "")
               (While (NOT(member Ans '("Y" "y" "N" "n")))
               (setq Ans (getstring "\nFile Already Exist...Replace (Y/N): ")))
               (If (member Ans '("Y" "y"))(setq Exist "N")))
      );end cond
   );end while
   (setq FU (open FN "w"))
   (foreach Macrow Maclist (print Macrow FU))
   (close FU))
;FUNCTION C:LAYEROFF-turns off a layer by picking an object on that layer   
(defun c:LAYEROFF (/ LAYER)
(setq LAYER
   (cdr
      (assoc 8
         (entget
            (car
               (entsel "Pick item on layer to turn off: "
))))))
(command "LAYER" "OFF" LAYER "Y" "")
)
;FUNCTION C:LAYERFRZ-freezes a layer by picking an object on that layer
(defun c:LAYERFRZ (/ LAYER)
(setq LAYER
   (cdr
      (assoc 8
         (entget
            (car
               (entsel "Pick item on layer to freeze: "
))))))
(command "LAYER" "FREEZE" LAYER "")
)
;FUNCTION C:CHGTEXT-changes a text string by string matching and substitution
(defun c:CHGTEXT (/ p l n e os as ns st s nsl osl sl si chf chm)
        (setq p (ssget))
        (if p (progn
           (setq osl (strlen (setq os
                         (getstring "\nOld string: " t))))
           (setq nsl (strlen (setq ns
                         (getstring "\nNew string: " t))))
           (setq l 0)
           (setq chm 0)
           (setq n (sslength p))
           (while (< l n)
              (if (= "TEXT"
                     (cdr (assoc 0
                       (setq e (entget (ssname p l))))))
                 (progn
                    (setq chf nil)
                    (setq s (cdr (setq as (assoc 1 e))))
                    (setq si 1)
                    (while (= osl (setq sl (strlen
                                  (setq st (substr s si osl)))))
                       (if (= st os) (progn
                          (setq s (strcat (substr s 1 (1- si)) ns
                                          (substr s (+ si osl))))
                          (setq chf t)
                       ))
                       (setq si (1+ si))
                    )
                    (if chf (progn
                       (setq e (subst (cons 1 s) as e))
                       (entmod e)
                       (setq chm (1+ chm))
                    ))
                 )
              )
              (setq l (1+ l))
           )
        ))
        (princ "Changed ")
        (princ chm)
        (princ " text lines.")
        (terpri)
)
